﻿Imports System.Threading
Imports System.Windows.Forms

Friend Class PluginForm
    Private UC As Plugininterface.Entry
    Dim PluginMain As UCCNCplugin
    Dim MustClose As Boolean = False

    Dim strMoveCode As String ' Use to hold the 'g code' string to run

    Dim thrMyProc As Thread ' Main thread for any probing op

    'Flags to kill threads
    Dim IsMovingFlag As Boolean = False
    Friend abortflag As Boolean = False

    Dim xmaxVel, ymaxVel, zmaxVel As Double


    Public Sub New(CallerPluginMain As UCCNCplugin)
        Me.UC = CallerPluginMain.UC
        Me.PluginMain = CallerPluginMain
        InitializeComponent()
    End Sub

    Private Sub PluginForm_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        tbfeed.Text = 5
        tbPDist.Text = 1
        tbretract.Text = 0.5
    End Sub

    Private Sub PluginForm_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        ' Do not close the form when the red X button is pressed
        ' But start a Thread which will stop the Loop call from the UCCNC
        ' to prevent the form closing while there is a GUI update in the Loop event
        If Not MustClose Then
            e.Cancel = True
            Dim thrClose As New Thread(Sub() Closeform())
            thrClose.CurrentCulture = Thread.CurrentThread.CurrentCulture ' Preserve regional settings
            thrClose.Start()
        Else
            ' Form is closing here...
        End If
    End Sub

    Public Sub Closeform()
        ' Stop the Loop event to update the GUI
        PluginMain.LoopStop = True
        ' Wait until the loop exited
        While (PluginMain.LoopWorking)
            Thread.Sleep(10)
        End While
        ' Set the mustclose variable to true and call the .Close() function to close the Form
        MustClose = True
        Me.Close()
    End Sub



    Private Function IsMoving() As Boolean
        Dim thrIsMoving As New Thread(Sub() CheckIsMoving())
        thrIsMoving.CurrentCulture = Thread.CurrentThread.CurrentCulture ' Maradjon angol!
        thrIsMoving.Start()
        While thrIsMoving.IsAlive
            Thread.Sleep(1)
        End While
        Return IsMovingFlag
    End Function



    Private Sub CheckIsMoving()
        IsMovingFlag = UC.IsMoving
    End Sub


    Sub rbJogStepSelected()
        If rbJogCont.Checked Then

            pnlJogBtn.Visible = True
            pnlGoTo.Visible = False

            nudJogStep.Visible = False
            nudJogVel.Visible = True
            'tbJogStepSize.Visible = False
            'tbJogVel.Visible = True
            lblStepSize.Visible = False
            lblJogVel.Visible = True




        ElseIf rbJogStep.Checked Then

            pnlJogBtn.Visible = True
            pnlGoTo.Visible = False

            nudJogStep.Visible = True
            nudJogVel.Visible = False
            'tbJogStepSize.Visible = True
            'tbJogVel.Visible = False
            lblStepSize.Visible = True
            lblJogVel.Visible = False



        ElseIf rbGoTo.Checked Then

            pnlJogBtn.Visible = False
            pnlGoTo.Visible = True
            pnlGoTo.BringToFront()

        End If
    End Sub



    Private Sub rbJogStep_CheckedChanged(sender As Object, e As EventArgs) Handles rbJogStep.CheckedChanged
        rbJogStepSelected()
    End Sub

    Private Sub rbJogcont_CheckedChanged(sender As Object, e As EventArgs) Handles rbJogCont.CheckedChanged
        rbJogStepSelected()
    End Sub

    Private Sub rbGoTo_CheckedChanged(sender As Object, e As EventArgs) Handles rbGoTo.CheckedChanged
        rbJogStepSelected()
    End Sub



    Private Sub btnGoTo_Click(sender As Object, e As EventArgs) Handles btnGoTo.Click

        If Not cbGoTORot.Checked AndAlso Not cbGoToX.Checked AndAlso Not cbGoToY.Checked AndAlso Not cbGoToZ.Checked Then

            MessageBox.Show(Me, "Appears no axis is set for moving, no move To make!")

                Return
        Else

            'If IsSpindleFlag = True And IsCamFlag = False Then
            '    Dim dobutton As DialogResult = MessageBox.Show("Camera is already active offset, continue?", "Proceed with offset?", MessageBoxButtons.YesNo)

            '    If dobutton = DialogResult.No Then
            '        Exit Sub
            '    Else

            '    End If

            'End If


            Try

                If thrMyProc Is Nothing Then

                    abortflag = False

                    thrMyProc = New Thread(AddressOf GOToThread)
                    thrMyProc.CurrentCulture = Thread.CurrentThread.CurrentCulture ' Stay in English
                    thrMyProc.Start()

                    ' Me.btnProbeGrid.Text = "STOP !"
                Else

                    'stop UCCNC first
                    UC.Stop()

                    abortflag = True

                    'thrMyProc.Abort() 'DONT DO THIS
                    thrMyProc = Nothing

                    ' Me.btnProbeGrid.Text = "Start Probing!"

                End If
            Catch ex As Exception
                MessageBox.Show(Me, "Didn't work....")
            End Try
        End If





    End Sub


    Private Sub btnGoToZero_Click(sender As Object, e As EventArgs) Handles btnGoToZero.Click

        If Not cbGoTORot.Checked AndAlso Not cbGoToX.Checked AndAlso Not cbGoToY.Checked AndAlso Not cbGoToZ.Checked Then
            Using New Centered_MessageBox(Me)
                MessageBox.Show(Me, "Appears no axis is set for moving, no move To make!")
            End Using

            Return
        Else



            Try

                If thrMyProc Is Nothing Then

                    abortflag = False

                    thrMyProc = New Thread(AddressOf GoToZeroThread)
                    thrMyProc.CurrentCulture = Thread.CurrentThread.CurrentCulture ' Stay in English
                    thrMyProc.Start()

                    ' Me.btnProbeGrid.Text = "STOP !"
                Else

                    'stop UCCNC first
                    UC.Stop()

                    abortflag = True

                    'thrMyProc.Abort() 'DONT DO THIS
                    thrMyProc = Nothing

                End If
            Catch ex As Exception
                MessageBox.Show(Me, "Didn't work....")
            End Try
        End If



    End Sub


    Public Sub GoToThread()

        Dim zstart, xstart, ystart, rotstart, feed, safe, zretract, zend, xend, yend, rotend, xpoint, ypoint, zpoint, rotpoint As Double

        Dim strMoveCode As String




        ' ABORT if needed to
        If UC.GetLED(25) Or UC.GetLED(36) Or UC.GetLED(217) Or abortflag Then ' Check for feedhold and cycle stop and reset
            Try
                Using New Centered_MessageBox(Me)

                    MessageBox.Show(Me, "Aborting offset move, UCCNC in reset!")
                End Using

                UC.AddStatusmessage("Aborting offset!")
                thrMyProc = Nothing
                Return
                'thrMyProc.Abort()

                Exit Sub
            Catch ex As Exception

            End Try

        End If





        ' ABORT if needed to

        xstart = UC.GetXpos
        ystart = UC.GetYpos
        zstart = UC.GetZpos

        Try

            If cbGoToX.Checked AndAlso tbGoToX.Text <> "" Then
                xpoint = Convert.ToDouble(tbGoToX.Text)

            End If

            If cbGoToY.Checked AndAlso tbGoToY.Text <> "" Then
                ypoint = Convert.ToDouble(tbGoToY.Text)

            End If


            If cbGoToZ.Checked AndAlso tbGoTOZ.Text <> "" Then
                zpoint = Convert.ToDouble(tbGoTOZ.Text)

            End If


            If cbGoTORot.Checked AndAlso tbGoToRot.Text <> "" Then
                rotpoint = Convert.ToDouble(tbGoToRot.Text)

            End If


            feed = nudGoTOVel.Value
        Catch ex As Exception

        End Try



        strMoveCode = "F" & feed

        'messagebox.show(me, strMoveCode)


        UC.Codesync(strMoveCode)
        While IsMoving()
            Thread.Sleep(5)
        End While

        ' Lift Z to safe height
        If cbZSafeLift.Checked Then

            GoToSafeZ()

        Else

        End If



        'Z First:



        If cbGoToZ.Checked AndAlso (zpoint > UC.GetZpos) Then

            If feed <> 0 Then
                strMoveCode = "G1 "
            Else
                strMoveCode = "G0 "
            End If

            strMoveCode = strMoveCode & " Z" & fn(zpoint)

            UC.Codesync(strMoveCode)

            While IsMoving()
                Thread.Sleep(5)
            End While

        End If


        'Move to location
        If feed <> 0 Then
            strMoveCode = "G1 "
        Else
            strMoveCode = "G0 "
        End If


        If cbGoToX.Checked Then
            strMoveCode = strMoveCode & " X" & fn(xpoint)
        End If

        If cbGoToY.Checked Then
            strMoveCode = strMoveCode & " Y" & fn(ypoint)
        End If








        UC.Codesync(strMoveCode)

        While IsMoving()
            Thread.Sleep(5)
        End While





        'strMoveCode = "G1 X" & fn(xpoint) & " Y" & fn(ypoint) & " F" & fn(feed)



        If (cbZSafeLift.Checked AndAlso cbZSafeReturn.Checked) Or (Not cbZSafeLift.Checked AndAlso Not cbZSafeReturn.Checked) Then
            If feed <> 0 Then

                If cbGoToZ.Checked Then
                    strMoveCode = "G31 z" & fn(zpoint) & " F" & fn(feed)
                Else
                    strMoveCode = "G31 z" & fn(zstart) & " F" & fn(feed)

                End If

            Else

                If cbGoToZ.Checked Then
                    strMoveCode = "G0 z" & fn(zpoint)
                Else
                    strMoveCode = "G0 z" & fn(zstart)

                End If

            End If

            UC.Codesync(strMoveCode)

            While IsMoving()
                Thread.Sleep(5)
            End While
        End If



        thrMyProc = Nothing



        Exit Sub




    End Sub


    Public Sub GoToZeroThread()

        Dim zstart, xstart, ystart, rotstart, feed, safe, zretract, zend, xend, yend, rotend, xpoint, ypoint, zpoint, rotpoint As Double

        Dim strMoveCode As String




        ' ABORT if needed to
        If UC.GetLED(25) Or UC.GetLED(36) Or UC.GetLED(217) Or abortflag Then ' Check for feedhold and cycle stop and reset
            Try
                Using New Centered_MessageBox(Me)

                    MessageBox.Show(Me, "Aborting offset move, UCCNC in reset!")
                End Using

                UC.AddStatusmessage("Aborting offset!")
                thrMyProc = Nothing
                Return
                'thrMyProc.Abort()

                Exit Sub
            Catch ex As Exception

            End Try

        End If





        ' ABORT if needed to

        xstart = UC.GetXpos
        ystart = UC.GetYpos
        zstart = UC.GetZpos

        Try

            If cbGoToX.Checked Then
                xpoint = 0

            End If

            If cbGoToY.Checked Then
                ypoint = 0

            End If


            If cbGoToZ.Checked Then
                zpoint = 0

            End If


            If cbGoTORot.Checked Then
                rotpoint = 0

            End If


            feed = nudGoTOVel.Value
        Catch ex As Exception

        End Try



        strMoveCode = "F" & feed

        'messagebox.show(me, strMoveCode)


        UC.Codesync(strMoveCode)
        While IsMoving()
            Thread.Sleep(5)
        End While

        ' Lift Z to safe height
        If cbZSafeLift.Checked Then

            GoToSafeZ()

        Else

        End If



        'Z First:



        If cbGoToZ.Checked AndAlso (zpoint > UC.GetZpos) Then

            If feed <> 0 Then
                strMoveCode = "G1 "
            Else
                strMoveCode = "G0 "
            End If

            strMoveCode = strMoveCode & " Z" & fn(zpoint)

            UC.Codesync(strMoveCode)

            While IsMoving()
                Thread.Sleep(5)
            End While

        End If


        'Move to location
        If feed <> 0 Then
            strMoveCode = "G1 "
        Else
            strMoveCode = "G0 "
        End If


        If cbGoToX.Checked Then
            strMoveCode = strMoveCode & " X" & fn(xpoint)
        End If

        If cbGoToY.Checked Then
            strMoveCode = strMoveCode & " Y" & fn(ypoint)
        End If


        'If cbGoToZ.Checked Then
        '    strMoveCode = strMoveCode
        'End If





        'strMoveCode = strMoveCode & " F" & fn(feed)

        UC.Codesync(strMoveCode)

        While IsMoving()
            Thread.Sleep(5)
        End While





        'strMoveCode = "G1 X" & fn(xpoint) & " Y" & fn(ypoint) & " F" & fn(feed)



        If (cbZSafeLift.Checked AndAlso cbZSafeReturn.Checked) Or (Not cbZSafeLift.Checked AndAlso Not cbZSafeReturn.Checked) Then
            If feed <> 0 Then

                If cbGoToZ.Checked Then
                    strMoveCode = "G31 z" & fn(zpoint) & " F" & fn(feed)
                Else
                    strMoveCode = "G31 z" & fn(zstart) & " F" & fn(feed)

                End If

            Else

                If cbGoToZ.Checked Then
                    strMoveCode = "G0 z" & fn(zpoint)
                Else
                    strMoveCode = "G0 z" & fn(zstart)

                End If

            End If

            UC.Codesync(strMoveCode)

            While IsMoving()
                Thread.Sleep(5)
            End While
        End If



        thrMyProc = Nothing


        Exit Sub




    End Sub





    Private Sub btnSimpleZ_Click(sender As Object, e As EventArgs) Handles btnZProbe.Click


        If thrMyProc IsNot Nothing Then
            Using New Centered_MessageBox(Me)
                MessageBox.Show(Me, "Already Running A Probe Cycle!  Please hit 'Abort Cycle' button.")
            End Using

            Exit Sub
        Else





            Try



                If thrMyProc Is Nothing Then


                    abortflag = False

                    thrMyProc = New Thread(AddressOf SimpleZProbe)
                    thrMyProc.CurrentCulture = Thread.CurrentThread.CurrentCulture
                    thrMyProc.Start()

                Else

                End If
            Catch ex As Exception
                MessageBox.Show(Me, "Didn't work....")
            End Try

        End If

    End Sub



    Public Function FaultCheck_perim() As Boolean
        Dim errMsg As String
        FaultCheck_perim = False


        If UC.GetLED(25) Or UC.GetLED(36) Or UC.GetLED(217) Then ' Check for feedhold and cycle stop and reset
            Try

                FaultCheck_perim = True

                MessageBox.Show("Aborting probing!! EStop or Feedhold")


                abortflag = True

                thrMyProc = Nothing


            Catch ex As Exception

            End Try

        End If

        'NEW, 2.013
        If UC.GetLED(26) Then ' Check for limit switches
            Try

                FaultCheck_perim = True

                MessageBox.Show("Aborting probing!! Limit hit")

                abortflag = True

                thrMyProc = Nothing

            Catch ex As Exception

            End Try

        End If






    End Function

    Public Function Tipcheck_perim() As Boolean


        Tipcheck_perim = False

        If UC.GetLED(37) Then ' Check for feedhold and cycle stop and reset
            Try

                Tipcheck_perim = True


                MessageBox.Show(Me, "Probe Active, aborting!")

                abortflag = True

                thrMyProc = Nothing


            Catch ex As Exception

            End Try

        End If
    End Function



    Sub SimpleZProbe()
        Dim newZ As Double = 0

        Dim ZStart, ProbeMax, Zend, ZHit, FRate1, ZClear, ZRetract As Double

        Try


            ZStart = UC.GetZpos 'GetoemDRO(802)
            ProbeMax = Convert.ToDouble(tbPDist.Text)
            '1
            FRate1 = Convert.ToDouble(tbfeed.Text)

            ZRetract = Convert.ToDouble(tbretract.Text)

            Zend = ZStart - ProbeMax




            '<<<<<<<<<<<< check probe tip before G31! >>>>>>>>>>>>>>>>>>>>>>>
            If Tipcheck_perim() Then
                thrMyProc = Nothing
                Return
            End If
            If FaultCheck_perim() Then
                thrMyProc = Nothing
                Return
            End If
            If abortflag Then
                thrMyProc = Nothing
                Return
            End If
            '<<<<<<<<<<<< check probe tip before G31! >>>>>>>>>>>>>>>>>>>>>>>	

            strMoveCode = "G31 z" & fn(Zend) & "f" & fn(FRate1)

            UC.Codesync(strMoveCode)
            While IsMoving()
                Thread.Sleep(5)
            End While

            ZHit = UC.Getvar(5063)

            If UC.Getvar(5060) = 1 Then 'check if hit something on way down, 0=HIT, 1=MISS




                strMoveCode = "G0 z" & fn(ZStart)  ' Lift Z to start

                UC.Codesync(strMoveCode)
                While IsMoving()
                    Thread.Sleep(5)
                End While

                MessageBox.Show("Missed!")

                thrMyProc = Nothing
                Return

            End If





            newZ = 0


            UC.Setfield(True, newZ, 228) ' Set ZDRO to center of ball, bottom of ball as surface variable.
            UC.Validatefield(True, 228)

            ZClear = newZ + Math.Abs(ZRetract)

            MessageBox.Show("ZHit =" & ZHit)


            Thread.Sleep(100)



            strMoveCode = "G0 z" & fn(ZClear)  ' Lift Z

            UC.Codesync(strMoveCode)
            While IsMoving()
                Thread.Sleep(5)
            End While






        Catch ex As Exception
            MessageBox.Show(Me, "Error in 'Z Probing'")

        End Try

        'CloseProbe()


    End Sub

#Region "Jog Buttons"



#Region "JOGGING ENABLE"



    Private Sub cbJogEnab_CheckedChanged(sender As Object, e As EventArgs) Handles cbJogEnab.CheckedChanged
        jogenabchangecheck()
    End Sub



    Sub jogenabchangecheck()
        If cbJogEnab.Checked = True Then
            rbJogCont.Enabled = True
            rbJogStep.Enabled = True
            btnJogDn.Enabled = True
            btnJogUp.Enabled = True
            btnJogRight.Enabled = True
            btnJogLeft.Enabled = True
            btnjogZup.Enabled = True
            btnjogZdown.Enabled = True
            btnJogRotaryUp.Enabled = True
            btnJogRotDown.Enabled = True

        Else
            rbJogCont.Enabled = False
            rbJogStep.Enabled = False
            btnJogDn.Enabled = False
            btnJogUp.Enabled = False
            btnJogRight.Enabled = False
            btnJogLeft.Enabled = False
            btnjogZup.Enabled = False
            btnjogZdown.Enabled = False
            btnJogRotaryUp.Enabled = False
            btnJogRotDown.Enabled = False

        End If
    End Sub

#End Region


    ' X and Y Jogs

    'Y Up
    Private Sub btnJogUp_Click_1(sender As Object, e As EventArgs) Handles btnJogUp.MouseDown
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(1, False, yvelPCT(nudJogVel.Value))
        End If
        If rbJogStep.Checked Then
            UC100.AddLinearMoveRel(1, nudJogStep.Value, 1, yvelPCT(nudJogVel.Value), False)
        End If
    End Sub
    Private Sub btnJogUp_Click_1a(sender As Object, e As EventArgs) Handles btnJogUp.MouseUp
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(1, False, 0)
        End If
    End Sub


    'X Left
    Private Sub btnJogLeft_Click(sender As Object, e As EventArgs) Handles btnJogLeft.MouseDown
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(0, True, xvelPCT(nudJogVel.Value))
        End If
        If rbJogStep.Checked Then
            UC100.AddLinearMoveRel(0, nudJogStep.Value, 1, xvelPCT(nudJogVel.Value), True)
        End If
    End Sub
    Private Sub btnJogLeft_Click1(sender As Object, e As EventArgs) Handles btnJogLeft.MouseUp
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(0, True, 0)
        End If
    End Sub

    'X Right
    Private Sub btnJogRight_Click(sender As Object, e As EventArgs) Handles btnJogRight.MouseDown
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(0, False, xvelPCT(nudJogVel.Value))
        End If
        If rbJogStep.Checked Then
            UC100.AddLinearMoveRel(0, nudJogStep.Value, 1, xvelPCT(nudJogVel.Value), False)
        End If
    End Sub
    Private Sub btnJogRight_Click1(sender As Object, e As EventArgs) Handles btnJogRight.MouseUp
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(0, False, 0)
        End If

    End Sub

    'Y Down
    Private Sub btnJogDn_Click(sender As Object, e As EventArgs) Handles btnJogDn.MouseDown
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(1, True, yvelPCT(nudJogVel.Value))
        End If
        If rbJogStep.Checked Then
            UC100.AddLinearMoveRel(1, nudJogStep.Value, 1, yvelPCT(nudJogVel.Value), True)
        End If
    End Sub
    Private Sub btnJogDn_Click1(sender As Object, e As EventArgs) Handles btnJogDn.MouseUp
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(1, True, 0)
        End If

    End Sub

    ' Z Jogs
    Private Sub btnjogZup_Click(sender As Object, e As EventArgs) Handles btnjogZup.MouseDown
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(2, False, zvelPCT(nudJogVel.Value))
        End If
        If rbJogStep.Checked Then
            UC100.AddLinearMoveRel(2, nudJogStep.Value, 1, zvelPCT(nudJogVel.Value), False)
        End If
    End Sub
    Private Sub btnjogZup_Click2(sender As Object, e As EventArgs) Handles btnjogZup.MouseUp
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(2, False, 0)
        End If
    End Sub

    Private Sub btnjogZdown_Click(sender As Object, e As EventArgs) Handles btnjogZdown.MouseDown
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(2, True, zvelPCT(nudJogVel.Value))
        End If
        If rbJogStep.Checked Then
            UC100.AddLinearMoveRel(2, nudJogStep.Value, 1, zvelPCT(nudJogVel.Value), True)
        End If
    End Sub

    Private Sub btnjogZdown_Click2(sender As Object, e As EventArgs) Handles btnjogZdown.MouseUp
        If rbJogCont.Checked Then
            UC100.JogOnSpeed(2, True, 0)
        End If
    End Sub


    Sub GoToSafeZ()
        strMoveCode = "m216"
        UC.Codesync(strMoveCode)

        'UC.Callbutton(216) ' skips ahead...

        'While Not IsMoving()
        '    Thread.Sleep(5)
        'End While

        While IsMoving()
            Thread.Sleep(5)
        End While
    End Sub



    Private Function xvelPCT(ByVal xvel As Double) As Double

        'Convert speed in 'unit/min' to 'Jog %'
        If xmaxVel = 0 And ymaxVel = 0 Then
            xmaxVel = UC.Getfielddouble(True, 9)
            ymaxVel = UC.Getfielddouble(True, 24)
            zmaxVel = UC.Getfielddouble(True, 39)

        End If

        xvelPCT = xvel / xmaxVel * 100 ' Define velocity as a % of max axis velocity, as input to JogOnSpeed command.
        Return xvelPCT
    End Function

    Private Function yvelPCT(ByVal yvel As Double) As Double

        'Convert speed in 'unit/min' to 'Jog %'
        If xmaxVel = 0 And ymaxVel = 0 Then
            xmaxVel = UC.Getfielddouble(True, 9)
            ymaxVel = UC.Getfielddouble(True, 24)
            zmaxVel = UC.Getfielddouble(True, 39)

        End If

        yvelPCT = yvel / ymaxVel * 100 ' Define velocity as a % of max axis velocity, as input to JogOnSpeed command.
        Return yvelPCT
    End Function

    Private Function zvelPCT(ByVal zvel As Double) As Double

        'Convert speed in 'unit/min' to 'Jog %'
        If xmaxVel = 0 And ymaxVel = 0 Then
            xmaxVel = UC.Getfielddouble(True, 9)
            ymaxVel = UC.Getfielddouble(True, 24)
            zmaxVel = UC.Getfielddouble(True, 39)
        End If

        zvelPCT = zvel / zmaxVel * 100 ' Define velocity as a % of max axis velocity, as input to JogOnSpeed command.
        Return zvelPCT
    End Function

    Public Function fn(ByRef val As Double)
        Return String.Format("{0:F4}", val)
        'Return String.Format("f6", val)
    End Function

    Public Function fn2(ByRef val As Double)
        Return String.Format("{0:F2}", val)
        'Return String.Format("f6", val)
    End Function

    Public Function fn3(ByRef val As Double)
        Return String.Format("{0:F3}", val)
        'Return String.Format("f6", val)
    End Function
#End Region

End Class